/**
 * The synchronizer-local module of the TinyBase project lets you synchronize
 * MergeableStore data to and from other MergeableStore instances on the same
 * local machine.
 * @see Synchronizing Data guide
 * @packageDocumentation
 * @module synchronizer-local
 * @since v5.0.0
 */

import {MergeableStore} from '../mergeable-store.d.ts';
import {Synchronizer} from '../synchronizers.d.ts';

/**
 * The LocalSynchronizer interface
 * @category Synchronizer
 */
export interface LocalSynchronizer extends Synchronizer {}

/**
 * The createLocalSynchronizer function
 * @category Creation
 */
export function createLocalSynchronizer(
  store: MergeableStore,
  onIgnoredError?: (error: any) => void,
): LocalSynchronizer;
