import {CellIdFromSchema, TableIdFromSchema} from './store.d.ts';
import {NoTablesSchema, OptionalTablesSchema} from '../store.d.ts';
import {Id} from '../common.d.ts';
import {ResultCell} from '../queries.d.ts';

export type JoinedCellIdOrId<
  Schema extends OptionalTablesSchema = NoTablesSchema,
  JoinedTableId extends TableIdFromSchema<Schema> | Id =
    | TableIdFromSchema<Schema>
    | Id,
> =
  JoinedTableId extends TableIdFromSchema<Schema>
    ? CellIdFromSchema<Schema, JoinedTableId>
    : Id;

export type GetResultCell = (cellId: Id) => ResultCell;
